/* Substitution.h -*- c++ -*- Hans-Peter Stoerr Wed Feb  3 1999 */

#ifndef _SUBSTITUTION_H
#define _SUBSTITUTION_H

#include <string>
#include <map>

class Substitution : public map<string,string,less<string> >
{
public:
  string operator()(const string s) const 
  {
    if (this->find(s)!=this->end()) return this->find(s)->second;
    else return s;
  }
  void  reset()
  {
    *this=Substitution();
  }
};

#endif
