/* misc.h -*- c++ -*- Hans-Peter Stoerr Tue Feb  9 1999 */
// misc. useful routines

#ifndef _MISC_H
#define _MISC_H

#include <set>
#include <string>
using namespace std;

set<string> Split(string s, const string sep);
pair<string,string> SplitPair(string s, const string sep);

struct OnStartupCall
{
  OnStartupCall(void(*fun)(void)) { (*fun)(); }
};

struct OnExitCall
{
  OnExitCall(void(*fun)(void)) { mFun=fun; }
  ~OnExitCall() { (*mFun)(); }
  void (*mFun)();
};

#endif
