;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  SNLP blocks world with 2 operators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (domain snlp-bw1)
    (:requirements :adl)
  
  (:predicates (clear ?x)
	       (on-table ?x)
	       (on ?x ?y))
  

    (:action stack
	       :parameters (?x ?y)
	       :precondition
	       (AND (clear ?x)
		    (clear ?y)
		    (on-table ?x))
	       :effect
	       (AND (on ?x ?y)
		    (NOT (on-table ?x))
		    (NOT (clear ?y))))
  (:action unstack
	     :parameters (?x ?y)
	     :precondition
	     (AND (clear ?x)
		  (on ?x ?y))
	     :effect
	     (AND (on-table ?x)
		  (NOT (on ?x ?y))
		  (clear ?y))))

(define (problem big-bw1)
    (:domain snlp-bw1)
  (:objects a b c d e f g h)
  (:init (on c a) (on-table b) (on-table a) (on-table h)
         (on e c) (on d b)
         (on f d) (on g e)
         (clear f)
         (clear g)
         (clear h))
  (:goal (AND (on a b)
               (on b c)
               (on c d)
               (on d e)
               (on e f)
               (on f g)
               (on g h))))
