// Hey Emacs! This is -*- c++ -*- ! :-)
// general.cc	-- Hans-Peter Stoerr Tue Feb  2 1999

#include <fstream>
#include <iostream>
using namespace std;
#include "general.h"

#if CHECKDESTRUCTION

static  ofstream allocs("Allocs", ios::out|ios::trunc);

long    Object::Count=0;

Object::Object() : mNumber(++Count)
{
  allocs << mNumber << "(" << this << ")" << "        construct.\n";
}

Object::Object(const Object&) : mNumber(++Count)
{
  allocs << mNumber << "(" << this << ")" << "        construct.\n";
}

Object::~Object()
{
  allocs << mNumber << "(" << this << ")" << "        deconstruct.\n";
}

#endif // CHECKDESTRUCTION

extern Option timing;
void PrintMyTiming(double time,char* file,int line,char* command)
{
  if(timing) cout << "\n" << file << ":" << line << ": Time "
                  << time << " for " << command << ".";
}
