// misc.cc -*- c++ -*- Hans-Peter Stoerr Tue Feb  9 1999

#include "misc.h"

set<string> Split(string s, const string sep)
{
  set<string> res;
  while(0!=s.size()){
    size_t split=s.find(sep);
    res.insert(s.substr(0,split));
    if(string::npos!=split) s=s.substr(split+sep.size());
    else s="";
  }
  return res;
}

pair<string,string> SplitPair(string s, const string sep)
{
  size_t split=s.find(sep);
  if(string::npos!=split)
    return make_pair(s.substr(0,split),s.substr(split+sep.size()));
  else return make_pair(string(s),string(""));
}
